


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    set RegName "*"
    set PID 0
    set SIG ""

    variable SigTaskList [list NULL]

    set sigList [list "NONE"  "HUP"  "INT"    "QUIT"    "ILL"   "TRAP" "BRK"  "IOT"  \
          "ABRT" "CORE" "EMT"  "FPE"  "KILL"   "BUS"     "SEGV"  "SYS"  "PIPE"        \
          "ALRM" "TERM" "URG"  "STOP" "TSTP"   "CONT"    "CHLD"  "CLD"  "TTIN"        \
          "TTOU" "IO"   "XCPU" "XFSZ" "VTALRM" "PROF"    "WINCH" "LOST"               \
          "USR1" "USR2"  "PRIO" "POLL" "PWR"    "WAITING" "LWP"   "FREEZE"             \
          "THAW" "CANCEL"]

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
    }

   proc do_create {} {
       variable RegName
       variable RegN
       variable RegT 
       variable RegP 
       variable RegF 
       variable RegA 
       variable RegI
       variable RegL
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SigTaskService \
            DefineRegister  $RegName SigTask "-n $RegN -t $RegT -p $RegP -f $RegF -a $RegA -l $RegL"} msg]

       if {$z == 0} {
           InsertLog "DefineRegister returned: [lindex $msg 5]"
       } else {
           InsertLog "DefineRegister failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquire {} {
       variable RegName
       global errorCode errorInfo
       variable SigTaskList 

       set z [catch {::namespace inscope ::urn:SigTaskService InquireRegisters $RegName} msg]
       if {$z == 0} {
           InsertLog "InquireRegisters returned:"
           set SigTaskList {*}
           foreach item [lindex $msg 5] {lappend SigTaskList $item; InsertLog "$item"}
       } else {
           InsertLog "InquireRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_delete {} {
       variable RegName 
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SigTaskService DeleteRegisters $RegName} msg]

       if {$z == 0} {
           InsertLog "DeleteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "DeleteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_write {} {
       variable RegName 
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SigTaskService WriteRegisters $RegName 0} msg]

       if {$z == 0} {
           InsertLog "WriteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_readattributes {} {
       variable RegName 
       global errorCode errorInfo
       variable SIG
       variable PID

       set z [catch {::namespace inscope ::urn:SigTaskService ReadRegistersAttributes $RegName} msg]

       if {$z == 0} {
           InsertLog "ReadRegistersAttributes returned: [lindex $msg 5]"
           set attrlist [second [first [lindex $msg 5]]]
           foreach attr $attrlist {
               switch [string range $attr 1 1] {
                  s  {set SIG [string range $attr 2 end]}
                  t  {set PID [string range $attr 2 end]}
                  default {}
               }
           }
       } else {
           InsertLog "ReadRegistersAttributes failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_writeattributes {} {
       variable RegName 
       variable SIG
       variable PID
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SigTaskService \
            WriteRegistersAttributes $RegName "-s $SIG -t $PID"} msg]

       if {$z == 0} {
           InsertLog "WriteRegistersAttributes returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegistersAttributes failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       variable RegName 
       variable PID
       variable SIG

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

            VERBOSE  {set Verbose [expr ($Verbose + 1) & 1]}

            CREATE   {do_create}
            DELETE   {do_delete}
            WRITEATTR  {do_writeattributes}
            READATTR   {do_readattributes}
            WRITE    {do_write}

            QUERY    {do_inquire}

            REGNAMES -
            REGNAME {set RegName [lindex $w 1]}

            PID    {set PID [lindex $w 1]}
            SIG    {set SIG [lindex $w 1]}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



